
#property copyright " 2005-2006 RickD"
#property link      "www.e2e-fx.net"
#property show_inputs

#define major   2
#define minor   1

#include <stdlib.mqh>
#include <stderror.mqh>

#import "mt4c.dll"
  int ErrorCode();
  string ErrorMsg();
  bool Init(string root, string acc, string master_acc);
  bool Read();
  bool Commit();
  
  int GetCmd();
  int GetTicket();
  int GetType();
  string GetSymbol();
  double GetLot();
  double GetOpenPrice();
  double GetSL();
  double GetTP();
  double GetClosePrice();
  int GetTimeLocal();
  int GetTimeServer();
#import

#import "IniFile.dll"
  bool ReadFile(string path);
  string GetValue(string key_name, string value_name, string def_value);
  int GetValueI(string key_name, string value_name, int def_value);
  double GetValueF(string key_name, string value_name, double def_value);
#import


#define   SET       1
#define   MODIFY    2
#define   CLOSE     3

extern string IniPath = "D:\\MT4\\mc\\mt4c.ini";

int Timer = 0;
string Root = "";
string MasterAcc = "";

int Slippage = 0;
int MaxTimeDiff = 0;
int MaxDeviation = 0;
int RepeatCount = 0;
bool ForceStops = false;

bool FixedLot = true;
double Lots = 0.1;
double kLot = 1;
double MinLot = 0.1;
int LotPrec = 1;

bool inited = false;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

void init () {
  Comment("");
  
  bool res = ReadFile(IniPath);
  if (!res) {
    Print("*** Cannot open ini file! ***");
    return;
  }

  Root = GetValue("Main", "Root", "");
  MasterAcc = GetValue("Main", "MasterAcc", "");
  
  res = Init(Root, AccountNumber(), MasterAcc);
  int err = ErrorCode();
  if (err == -1) {
    Print("*** ", ErrorMsg(), " ***");
    return;
  }
  
  inited = true;
}

void deinit() {
  Comment("");
}

void start() {
  
  if (!inited) return;

  while (!IsStopped()) {
    Comment(
      "MT4 Client ", major, ".", minor, 
      "\nTime: ", TimeToStr(LocalTime(), TIME_DATE|TIME_SECONDS));

    bool res = ReadFile(IniPath);
    if (!res) {
      Print("*** Cannot open ini file! ***");
      break;
    }

    Timer = GetValueI("Main", "Timer", 3);
    
    Slippage = GetValueI("Orders", "Slippage", 3);
    MaxTimeDiff = GetValueI("Orders", "MaxTimeDiff", 180);
    MaxDeviation = GetValueI("Orders", "MaxDeviation", 20);
    RepeatCount = GetValueI("Orders", "RepeatCount", 3);    
    ForceStops = (GetValue("Orders", "ForceStops", "no") == "yes");

    FixedLot = (GetValue("MM", "FixedLot", "yes") == "yes");
    Lots = GetValueF("MM", "Lots", 0.1);
    kLot = GetValueF("MM", "kLot", 1);
    MinLot = GetValueF("MM", "MinLot", 0.1);
    LotPrec = GetValueI("MM", "LotPrec", 1);

    main();
    
    Sleep(Timer);
  }
}

void main() 
{
  bool res = Read();
  int err = ErrorCode();
  if (err == -1) {
    Print("*** ", ErrorMsg(), " ***");
    return;
  }

  if (!res) return;

  int cmd = GetCmd();
  int ticket = GetTicket();
  
  int tm = GetTimeLocal();
  if (TimeLocal() - tm > MaxTimeDiff) {
    Print("*** Ticket: " +ticket+ ". Command: " +cmd+ ". Maximum timeout exceeded! ***");
    Commit2();
    return;
  }


  
  if (cmd == SET) OnSet();
  if (cmd == MODIFY) OnModify();
  if (cmd == CLOSE) OnClose();
}

void Commit2()
{
  Commit();
  int err = ErrorCode();
  if (err == -1) {
    Print("*** ", ErrorMsg(), " ***");
    return;
  }
}

void OnSet()
{
  int ticket = GetTicket();
  int type = GetType();
  string symbol = GetSymbol();
  double lot = GetLot();
  double open_price = GetOpenPrice();
  double sl = GetSL();
  double tp = GetTP();

  int ticket2 = GetOrderM(ticket);
  if (ticket2 != -1) {
    Print("*** OnSet: the same market/pending order found, skipped! ***");
    Commit2();
    return;
  }

  ticket2 = GetOrderH(ticket);
  if (ticket2 != -1) {
    Print("*** OnSet: the same history order found, skipped! ***");
    Commit2();
    return;
  }
  
  if (type == OP_BUY) 
  {
    RefreshRates();
    
    double ask = MarketInfo(symbol, MODE_ASK);
    double point = MarketInfo(symbol, MODE_POINT);
    
    if (MathAbs(open_price - ask) > MaxDeviation*point) {
      Print("*** OnSet: maximum deviation exceeded! ***");
      Print("open_price= ", open_price, "ask= ", ask, "MaxDeviation= ", MaxDeviation, " point= ", point);
      Commit2();
      return;
    }
    
    for (int i=0; i < RepeatCount; i++)
    {
      RefreshRates();
      ask = MarketInfo(symbol, MODE_ASK);
    
      int res = Buy(symbol, GetLot2(lot), ask, Slippage, sl, tp, ticket);
      if (res == -1) continue;
      break;
    }
    
  }

  if (type == OP_SELL) 
  {
    RefreshRates();
    
    double bid = MarketInfo(symbol, MODE_BID);
    point = MarketInfo(symbol, MODE_POINT);
    
    if (MathAbs(open_price - bid) > MaxDeviation*point) 
    {
      Print("*** OnSet: maximum deviation exceeded! ***");
      Print("open_price= ", open_price, "ask= ", ask, "MaxDeviation= ", MaxDeviation, " point= ", point);      
      Commit2();
      return;
    }

    for (i=0; i < RepeatCount; i++)
    {
      RefreshRates();
      bid = MarketInfo(symbol, MODE_BID);

      res = Sell(symbol, GetLot2(lot), bid, Slippage, sl, tp, ticket);
      if (res == -1) continue;
      break;
    }
  }
  
  if (type == OP_BUYSTOP) {
    SetBuyStop(symbol, GetLot2(lot), open_price, Slippage, sl, tp, ticket);
  }

  if (type == OP_SELLSTOP) {
    SetSellStop(symbol, GetLot2(lot), open_price, Slippage, sl, tp, ticket);
  }
  
  if (type == OP_BUYLIMIT) {
    SetBuyLimit(symbol, GetLot2(lot), open_price, Slippage, sl, tp, ticket);
  }
  
  if (type == OP_SELLLIMIT) {
    SetSellLimit(symbol, GetLot2(lot), open_price, Slippage, sl, tp, ticket);
  }  


  Commit2();
}

void OnModify()
{
  int ticket0 = GetTicket();
  int type = GetType();
  string symbol = GetSymbol();
  double lot = GetLot();
  double open_price = GetOpenPrice();
  double sl = GetSL();
  double tp = GetTP();

  int ticket = GetOrderM(ticket0);
  if (ticket == -1) {
    Print("*** OnModify: no orders found! ***");
    Commit();
    return;
  }

  ModifyOrder(ticket, open_price, sl, tp);
  
  Commit2();
}

void OnClose()
{
  int ticket0 = GetTicket();
  int type = GetType();
  string symbol = GetSymbol();
  double lot = GetLot();
  double open_price = GetOpenPrice();
  double sl = GetSL();
  double tp = GetTP();
  double close_price = GetClosePrice();

  int ticket = GetOrderM(ticket0);
  if (ticket == -1) {
    Print("*** OnClose: no orders found! ***");
    Commit2();
    return;
  }

  if (type == OP_BUY || type == OP_SELL)
  {
    if (!ForceStops && (close_price == sl || close_price == tp))
    {
      Print("Close: action refused by ForceStops flag.");
      Commit2();
      return;
    }
  }
  
  if (type == OP_BUY) 
  {
    for (int i=0; i < RepeatCount; i++)
    {
      RefreshRates();
      bool res = CloseOrder(ticket, GetLot2(lot), MarketInfo(symbol, MODE_BID), Slippage);
      if (!res) continue;
      break;
    }
  }

  if (type == OP_SELL) 
  {
    for (i=0; i < RepeatCount; i++)
    {
      RefreshRates();
      res = CloseOrder(ticket, GetLot2(lot), MarketInfo(symbol, MODE_ASK), Slippage);
      if (!res) continue;
      break;
    }
  }
  
  if (type == OP_BUYSTOP || type == OP_SELLSTOP || type == OP_BUYLIMIT || type == OP_SELLLIMIT) {
    DeleteOrder(ticket);
  }
  
  Commit2();
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

int GetOrderM(int magic) {
  int cnt = OrdersTotal();
  for (int i = 0; i < cnt; i++) {
    if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;
    
    if (OrderMagicNumber() == magic) return (OrderTicket());
  }
  
  return (-1);
}

int GetOrderH(int magic) {
  int cnt = HistoryTotal();
  for (int i = 0; i < cnt; i++) {
    if (!OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) continue;
    
    if (OrderMagicNumber() == magic) return (OrderTicket());
  }
  
  return (-1);
}

double GetLot2(double lot) 
{
  if (FixedLot) 
    return (MathMax(lot, MinLot));
  else  
    return (NormalizeDouble(kLot*lot, LotPrec));
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

int SleepOk = 2000;
int SleepErr = 6000;

int Buy(string symbol, double lot, double price, int slip, double sl, double tp, int magic, string comment="") 
{
  int dig = MarketInfo(symbol, MODE_DIGITS);

  price = NormalizeDouble(price, dig);
  sl = NormalizeDouble(sl, dig);
  tp = NormalizeDouble(tp, dig);
    
  string _lot = DoubleToStr(lot, LotPrec);
  string _price = DoubleToStr(price, dig);
  string _sl = DoubleToStr(sl, dig);
  string _tp = DoubleToStr(tp, dig);

  Print("Buy \"", symbol, "\", ", _lot, ", ", _price, ", ", slip, ", ", _sl, ", ", _tp, ", ", magic, ", \"", comment, "\"");


  int res = OrderSend(symbol, OP_BUY, lot, price, slip, sl, tp, comment, magic);
  if (res >= 0) {
    Sleep(SleepOk);
    return (res);
  } 	
   	
  int code = GetLastError();
  Print("Error opening BUY order: ", ErrorDescription(code), " (", code, ")");
  Sleep(SleepErr);
	
  return (-1);
}

int Sell(string symbol, double lot, double price, int slip, double sl, double tp, int magic, string comment="") 
{
  int dig = MarketInfo(symbol, MODE_DIGITS);

  price = NormalizeDouble(price, dig);
  sl = NormalizeDouble(sl, dig);
  tp = NormalizeDouble(tp, dig);
  
  string _lot = DoubleToStr(lot, LotPrec);
  string _price = DoubleToStr(price, dig);
  string _sl = DoubleToStr(sl, dig);
  string _tp = DoubleToStr(tp, dig);

  Print("Sell \"", symbol, "\", ", _lot, ", ", _price, ", ", slip, ", ", _sl, ", ", _tp, ", ", magic, ", \"", comment, "\"");

  
  int res = OrderSend(symbol, OP_SELL, lot, price, slip, sl, tp, comment, magic);
  if (res >= 0) {
    Sleep(SleepOk);
    return (res);
  } 	
   	
  int code = GetLastError();
  Print("Error opening SELL order: ", ErrorDescription(code), " (", code, ")");
  Sleep(SleepErr);
	
  return (-1);
}

int SetBuyStop(string symbol, double lot, double price, int slip, double sl, double tp, int magic, string comment="") 
{
  int dig = MarketInfo(symbol, MODE_DIGITS);

  price = NormalizeDouble(price, dig);
  sl = NormalizeDouble(sl, dig);
  tp = NormalizeDouble(tp, dig);
  
  string _lot = DoubleToStr(lot, LotPrec);
  string _price = DoubleToStr(price, dig);
  string _sl = DoubleToStr(sl, dig);
  string _tp = DoubleToStr(tp, dig);

  Print("SetBuyStop \"", symbol, "\", ", _lot, ", ", _price, ", ", slip, ", ", _sl, ", ", _tp, ", ", magic, ", \"", comment, "\"");

  
  int res = OrderSend(symbol, OP_BUYSTOP, lot, price, slip, sl, tp, comment, magic);
  if (res >= 0) {
    Sleep(SleepOk);
    return (res);
  } 	
   	
  int code = GetLastError();
  Print("Error setting BUYSTOP order: ", ErrorDescription(code), " (", code, ")");
  Sleep(SleepErr);
	
  return (-1);
}

int SetSellStop(string symbol, double lot, double price, int slip, double sl, double tp, int magic, string comment="") 
{
  int dig = MarketInfo(symbol, MODE_DIGITS);

  price = NormalizeDouble(price, dig);
  sl = NormalizeDouble(sl, dig);
  tp = NormalizeDouble(tp, dig);
    
  string _lot = DoubleToStr(lot, LotPrec);
  string _price = DoubleToStr(price, dig);
  string _sl = DoubleToStr(sl, dig);
  string _tp = DoubleToStr(tp, dig);

  Print("SetSellStop \"", symbol, "\", ", _lot, ", ", _price, ", ", slip, ", ", _sl, ", ", _tp, ", ", magic, ", \"", comment, "\"");

 
  int res = OrderSend(symbol, OP_SELLSTOP, lot, price, slip, sl, tp, comment, magic);
  if (res >= 0) {
    Sleep(SleepOk);
    return (res);
  } 	
   	
  int code = GetLastError();
  Print("Error setting SELLSTOP order: ", ErrorDescription(code), " (", code, ")");
  Sleep(SleepErr);
	
  return (-1);
}

int SetBuyLimit(string symbol, double lot, double price, int slip, double sl, double tp, int magic, string comment="") 
{
  int dig = MarketInfo(symbol, MODE_DIGITS);

  price = NormalizeDouble(price, dig);
  sl = NormalizeDouble(sl, dig);
  tp = NormalizeDouble(tp, dig);
    
  string _lot = DoubleToStr(lot, LotPrec);
  string _price = DoubleToStr(price, dig);
  string _sl = DoubleToStr(sl, dig);
  string _tp = DoubleToStr(tp, dig);

  Print("SetBuyLimit \"", symbol, "\", ", _lot, ", ", _price, ", ", slip, ", ", _sl, ", ", _tp, ", ", magic, ", \"", comment, "\"");

  
  int res = OrderSend(symbol, OP_BUYLIMIT, lot, price, slip, sl, tp, comment, magic);
  if (res >= 0) {
    Sleep(SleepOk);
    return (res);
  } 	
   	
  int code = GetLastError();
  Print("Error setting BUYLIMIT order: ", ErrorDescription(code), " (", code, ")");
  Sleep(SleepErr);
	
  return (-1);
}

int SetSellLimit(string symbol, double lot, double price, int slip, double sl, double tp, int magic, string comment="") 
{
  int dig = MarketInfo(symbol, MODE_DIGITS);

  price = NormalizeDouble(price, dig);
  sl = NormalizeDouble(sl, dig);
  tp = NormalizeDouble(tp, dig);
    
  string _lot = DoubleToStr(lot, LotPrec);
  string _price = DoubleToStr(price, dig);
  string _sl = DoubleToStr(sl, dig);
  string _tp = DoubleToStr(tp, dig);

  Print("SetSellLimit \"", symbol, "\", ", _lot, ", ", _price, ", ", slip, ", ", _sl, ", ", _tp, ", ", magic, ", \"", comment, "\"");
  
  int res = OrderSend(symbol, OP_SELLLIMIT, lot, price, slip, sl, tp, comment, magic);
  if (res >= 0) {
    Sleep(SleepOk);
    return (res);
  } 	
   	
  int code = GetLastError();
  Print("Error setting SELLLIMIT order: ", ErrorDescription(code), " (", code, ")");
  Sleep(SleepErr);
	
  return (-1);
}

bool ModifyOrder(int ticket, double price, double sl, double tp) 
{
  int dig = MarketInfo(OrderSymbol(), MODE_DIGITS);

  price = NormalizeDouble(price, dig);
  sl = NormalizeDouble(sl, dig);
  tp = NormalizeDouble(tp, dig);
    
  string _price = DoubleToStr(price, dig);
  string _sl = DoubleToStr(sl, dig);
  string _tp = DoubleToStr(tp, dig);
  
  Print("ModifyOrder ", ticket, ", ", _price, ", ", _sl, ", ", _tp);
   
  double price0 = NormalizeDouble(OrderOpenPrice(), dig);
  double sl0 = NormalizeDouble(OrderStopLoss(), dig);
  double tp0 = NormalizeDouble(OrderTakeProfit(), dig);
  
  if (price == price0 && sl == sl0 && tp == tp0) return (true);


  bool res = OrderModify(ticket, price, sl, tp, 0);
  if (res) {
    Sleep(SleepOk);
    return (res);
  } 	
   	
  int code = GetLastError();
  Print("ModifyOrder failed: ", ErrorDescription(code), " (", code, ")");
  Sleep(SleepErr);
	
  return (false);
}

bool CloseOrder(int ticket, double lot, double price, int slip) 
{
  int dig = MarketInfo(OrderSymbol(), MODE_DIGITS);

  string _lot = DoubleToStr(lot, LotPrec);
  string _price = DoubleToStr(price, dig);

  Print("CloseOrder ", ticket, ", ", _lot, ", ", _price, ", ", slip);
  
  bool res = OrderClose(ticket, lot, price, slip);
  if (res) {
    Sleep(SleepOk);
    return (res);
  } 	
   	
  int code = GetLastError();
  Print("CloseOrder failed: ", ErrorDescription(code), " (", code, ")");
  Sleep(SleepErr);
	
  return (false);
}

bool DeleteOrder(int ticket) {

  Print("DeleteOrder ", ticket);
  
  bool res = OrderDelete(ticket);
  if (res) {
    Sleep(SleepOk);
    return (res);
  } 	
   	
  int code = GetLastError();
  Print("DeleteOrder failed: ", ErrorDescription(code), " (", code, ")");
  Sleep(SleepErr);
	
  return (false);
}

